/*
 * For Folded Text Plugin
 *
 * @author Fabian van-de-l_Isle <webmaster [at] lajzar [dot] co [dot] uk>
 * @author Christopher Smith <chris [at] jalakai [dot] co [dot] uk>
 * @author Robin Gareus <robin@gareus.org>
 */

// containers for localised reveal/hide strings, 
// populated from html comments in hidden elements on the page
var menufold_reveal = 'reveal';
var menufold_hide = 'hide';

/*
 * toggle the folded element via className change
 * also adjust the classname and title tooltip on the folding link
 */
function menufold_toggle(evt) {
  id = this.href.match(/#(.*)$/)[1];
  e = $(id);
  if (!e) return;

  if (e.className.match(/\bhidden\b/)) {
    e.className = e.className.replace(/\bhidden\b/g,'');
    e.className = e.className.replace(/  /g,' ');

    this.title = menufold_hide;
    menufold_closeallbut(this.href);
    document.cookie = "menufold" + "=" + escape(this.href);

    this.className += ' open';
  } else {
    e.className += ' hidden';

    this.title = menufold_reveal;
    document.cookie = "menufold" + "=" + escape('');

    this.className = this.className.replace(/\bopen\b/g,'');
    this.className = this.className.replace(/  /g,' ');
  }

  evt.preventDefault();
  return false;
}

function menufold_closeallbut (open) {
  var as=document.getElementsByTagName("a");
  var i;
  for(i=1;i<as.length;i++)  {
    if (as[i].href.search(/#menufold_/)!= -1) {
      if (as[i].href != open) {
    /*alert (as[i].href); */
        id = as[i].href.match(/#(.*)$/)[1];
        e = $(id);
        e.className += ' hidden';
        as[i].title = menufold_reveal;
        as[i].className = as[i].className.replace(/\bopen\b/g,'');
        as[i].className = as[i].className.replace(/  /g,' ');
      }
    }
  }
}


// custom language strings for the plugin

/*
 * run on document load, setup everything we need
 */
function menufold_setup() {
  /*
  // extract and save localised title tooltip strings
  var eStrings = $('reveal','hide'); 
  if (!eStrings[0]) return;

  menufold_reveal = eStrings[0].innerHTML.match(/^<!-- (.*) -->$/)[1];
  menufold_hide = eStrings[1].innerHTML.match(/^<!-- (.*) -->$/)[1];
  */
  // find all folder links, assign onclick handler and title tooltip for initial state
  var folds = getElementsByClass('menufolder');
  for (var i=0; i<folds.length; i++) {    
    addEvent(folds[i], 'click', menufold_toggle);
    folds[i].title = menufold_reveal;
  }
}

addInitEvent(menufold_setup);

// support graceful js degradation, this hides the folded blocks from view before they are shown, 
// whilst still allowing non-js user to see any folded content.
document.write('<style type="text/css" media="screen"><!--/*--><![CDATA[/*><!--*/ .menufold.hidden { display: none; } .menufolder .menuindicator { visibility: visible; } /*]]>*/--></style>');
