<?php
/**
 * Template Switcher via Action Plugin
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Gerry Weissbach <gerry.w@gammaproduction.de>
 */

if(!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../').'/');
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'action.php');

/**
 * All DokuWiki plugins to extend the parser/rendering mechanism
 * need to inherit from this class
 */
class action_plugin_tplSwitcher extends DokuWiki_Action_Plugin {

	var $registerHook = true;

    /**
     * return some info
     */
    function getInfo(){
        return array(
            'author' => 'Gerry Weissbach',
            'email'  => 'gerry.w@gammaproduction.de',
            'date'   => '2006-11-13',
            'name'   => 'Template Switcher',
            'desc'   => 'adds a Button to the Template to fastly switch a template for the Session',
            'url'    => 'http://wiki.gammaproduction.de/english/dokuwiki/plugins/tplSwitcher',
        );
    }

    /**
     * plugin should use this method to register its handlers with the dokuwiki's event controller
     *
     * @param    $controller   Dokuwiki's event controller object. Also available as global $EVENT_HANDLER
     *
     * @return   not required
     */
    function register(&$controller) {
		global $conf;

      $this->gwCheckLocalProtected();
      if ( $this->registerHook ) $controller->register_hook("DOKUWIKI_STARTED", "AFTER", $this, gwchangetemplate, $ACT);

    }

	function gwchangetemplate(&$event, $param) {
		global $conf;
	
		//$_SESSION['tplSwitch']=empty($param)?(empty($_SESSION['tplSwitch'])?$conf['template']:$_SESSION['tplSwitch']):htmlspecialchars($param);
		//$conf['template'] = $_SESSION['tplSwitch'];
	
		//Redefine
		//define('DOKU_TPL', DOKU_BASE.'lib/tpl/'.$conf['template'].'/');
	  	//define('DOKU_TPLINC', DOKU_INC.'lib/tpl/'.$conf['template'].'/');
	}

	function gwCheckLocalProtected()
	{
		global $conf;

		$content = 	'session_name(\'DokuWiki\');'."\n".'session_start();'."\n".
				
				'$_SESSION[\'tplSwitch\']=empty($_REQUEST[\'tplSwitch\'])?(empty($_SESSION[\'tplSwitch\'])?$conf[\'template\']:$_SESSION[\'tplSwitch\']):htmlspecialchars($_REQUEST[\'tplSwitch\']);'."\n".
				
				'$conf[\'template\'] = $_SESSION[\'tplSwitch\'];'."\n".
				'if (empty($conf[\'template\'])) $conf[\'template\'] = \'default\';'."\n".

				'header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1'."\n".
				
				'if(strstr($_SERVER[\'PHP_SELF\'], \'css\')) {'."\n".
				"\t".'if( strstr(strtolower($_SERVER[HTTP_USER_AGENT]), "opera") != FALSE'.
				' || strstr(strtolower($_SERVER[HTTP_USER_AGENT]), "msie") != FALSE'.
				'){'."\n".
				"\t"."\t".'header("HTTP/1.x 205 OK");'."\n".
				"\t".'} else {'."\n".
				"\t"."\t".'header("HTTP/1.x 200 OK");'."\n".
				"\t".'}'."\n".
				'}else'."\n".

				"\t".'if( !strpos(strtolower($_SERVER[HTTP_USER_AGENT]), "msie") === FALSE'.
				'){'."\n".
				"\t"."\t".'header("HTTP/1.x 200 OK");'."\n".
				"\t"."\t".'//echo "msie change";'."\n".
				"\t".'}else'."\n".
				"\t"."\t".'header("HTTP/1.x 200 OK");'."\n".
				
				'header("X-TemplateHeader: ".$conf[\'template\']); // HTTP/1.1'."\n".

				'session_write_close();'."\n".

				"\n";
	
		if ( file_exists(DOKU_CONF.'local.protected.php') )
		{
			
			
			if ( is_readable(DOKU_CONF.'local.protected.php') && is_writeable(DOKU_CONF.'local.protected.php') )
			{
				if ( !strstr(implode("", ($fileContent = file(DOKU_CONF.'local.protected.php'))), $content) )
				{
					array_pop($fileContent);
					
					$fp = fopen(DOKU_CONF.'local.protected.php',"w");
					fputs($fp, implode("", $fileContent)."\n".$content);
					fputs($fp, "?>\n");
					fclose($fp);

					if ( is_readable(DOKU_CONF.'local.php') && is_writeable(DOKU_CONF.'local.php'))
					{
						$content = '@include(DOKU_CONF."local.protected.php");';
						if ( !strstr(implode("", ($fileContent = file(DOKU_CONF.'local.php'))), $content) )
						{
							array_pop($fileContent);
					
							$fp = fopen(DOKU_CONF.'local.php',"w");
							fputs($fp, implode("", $fileContent)."\n".$content);
							fputs($fp, "?>\n");
							fclose($fp);
						}
					}
				}
				else
					$this->registerHook = false;
			}
			else if ( is_readable(DOKU_CONF.'local.php') && is_writeable(DOKU_CONF.'local.php'))
			{
				if ( !strstr(implode("", ($fileContent = file(DOKU_CONF.'local.php'))), $content) )
				{
					array_pop($fileContent);
					
					$fp = fopen(DOKU_CONF.'local.php',"w");
					fputs($fp, implode("", $fileContent)."\n".$content);
					fputs($fp, "?>\n");
					fclose($fp);
				}
				else
					$this->registerHook = false;
			}
		}
		else if ( is_writeable(DOKU_CONF) )
		{
			$fp = fopen(DOKU_CONF.'local.protected.php',"w");
			fputs($fp, "<?php\n/*\n * Dokuwiki Local Protected Configuration File\n * Auto-generated by tplSwitcher plugin \n * Date: ".date('Y-m-d H:s:i')."\n */\n");
			fputs($fp, $content);
			fputs($fp, "// end auto-generated content\n?>\n");
			fclose($fp);
		}
		else
			echo "Nothing done in tplSwitch";
		
	}
}

function tplSwitcher($template='default', $name='Default', $akey=null)
{
	global $ID;
	global $lang;

	$lang['btn_'.$name] = $name;
	print html_btn($name, $ID, $akey, array(/*'do'=>'show',*/ 'tplSwitch'=>$template), 'post', 'Change Template');
}

//Setup VIM: ex: et ts=4 enc=utf-8 :