<?php
/**
 * tplSwitcher
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Gerry Weissbach <gerry.w@gammaproduction.de>
 */

if(!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../').'/');
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');

class syntax_plugin_tplSwitcher extends DokuWiki_Syntax_Plugin {
    /**
     * return some info
     */
    function getInfo(){
        return array(
            'author' => 'Gerry Weissbach',
            'email'  => 'gerry.w@gammaproduction.de',
            'date'   => '2006-08-01',
            'name'   => 'Template Switcher',
            'desc'   => 'adds a Button to the Template to fastly switch a template for the Session',
            'url'    => 'http://wiki.gammaproduction.de/dokuwiki/plugins/template_switcher',
        );
    }

    /**
     * What kind of syntax are we?
     */
    function getType(){
        return 'substition';
    }

    /**
     * What about paragraphs?
     */
    function getPType(){
        return 'block';
    }

    /**
     * Where to sort in?
     */
    function getSort(){
        return 301;
    }


    /**
     * Connect pattern to lexer
     */
    function connectTo($mode) { $this->Lexer->addEntryPattern('{{tplSwitcher>(?=.*}})',$mode,'plugin_tplSwitcher'); }
    function postConnect() { $this->Lexer->addExitPattern('}}','plugin_tplSwitcher'); }


    /**
     * Handle the match
     */
    function handle($match, $state, $pos, &$handler){

        if ($state == DOKU_LEXER_UNMATCHED){

		$match = split('%',$match,2);

		$description = $match[1];
		$match = explode('||',$match[0]);

		if ( is_array($match) )
		{
			$i = 0;
			foreach ( $match AS $template)
			{
				$template = explode('|',$template);
				$result[$i]['template'] = $template[0];
				$result[$i]['name'] = !empty($template[1])?$template[1]:$template[0];
				$i ++;
			}
		}

	       return array($state, array('result'=>$result, 'desc'=>$description));
	}
        //handle params

        return false;
    }

    /**
     * Create output
     */
    function render($mode, &$renderer, $data) {
    	global $conf, $ID;

        if($mode == 'xhtml'){
            switch ($data[0]){
              case DOKU_LEXER_ENTER:
                break;

              case DOKU_LEXER_UNMATCHED:
			$description = $data[1]['desc'];
			$data[1] = $data[1]['result'];

			if ( sizeof( $data[1] ) > 1 )
			{
				srand((double)microtime() * 1000000);
				$number = rand();

		        	$output =	'<form action="' . wl($ID). '" method="post" name="tplSwitcher' . $number . '">' .
		        			'<input type="hidden" name="do" value="show" />' .
		        			(!empty($description)?$description:'').'<select name="tplSwitch" class="edit" onchange="document.tplSwitcher' . $number . '.submit();">' .
	    					'<option value="default">----</option>';

				foreach ( $data[1] AS $template )
					$output .= '<option value="' . $template['template'] . '">' . $template['name'] . '</option>';

				$output .= '</select>'.
				'<input type="submit" name="tplSubmit" id="tplChanger' . $number . '" value="change" class="button" title="change template" />' .
				'</form><script type="text/javascript" charset="utf-8">document.getElementById("tplChanger' . $number . '").style.display="none";</script>';
			  }
			else
		        	$output =	'<form action="' . wl($ID). '" method="post">' .
//		        			'<input type="hidden" name="do" value="show" />' .
		        			'<input type="hidden" name="tplSwitch" value="' . $data[1][0]['template'] . '" />' .
		        			(!empty($description)?$description:'').'<input type="submit" name="tplSubmit" value="' . $data[1][0]['name'] . '" class="button" title="change template to ' . $data[1][0]['name'] . '" />' .
		        			'</form>';

			$renderer->doc .=  $output;

                break;

              case DOKU_LEXER_EXIT:
                break;
            }
            return true;
        }
        return false;
    }
}
//Setup VIM: ex: et ts=4 enc=utf-8 :
